//XmlNode.h
#ifndef __XMLNODE_H
#define __XMLNODE_H

#include <list>
#include <string>
#include <vector>
#include "../tinyxml/tinyxml.h"


class XmlNode;
typedef std::vector<XmlNode*> XmlNodeVector;


class XmlNode
{
public:
	XmlNode();
	virtual	~XmlNode();
	virtual	const char*	GetClassName();

	XmlNode*		AttachChild( XmlNode* pChild );
	void			DetachChild( XmlNode* pChild );
	void			DetachChild();
	XmlNode*		GetRoot();
	XmlNode*		GetParent();

	XmlNode&		SetData( std::string data );
	XmlNode&		SetData( const char* pData );
	std::string*	GetData();
	static void		PrintAll( XmlNode* pNode );
	static void		WriteXml( XmlNode* pNode, TiXmlNode* pXml );
	
	std::string*	GetName();
	XmlNode&		SetName( const char* szName );
	std::string*	GetAttribute( const char* szName );
	XmlNode&		AddAttribute( const char* pName, const char* pValue );
	XmlNode*		FindFirstChild( const char* pName );  //ڼտ ã´.
	void			FindChild( const char* pName, XmlNodeVector& nodeArr ); // ڼտ ã´
	void    		FindNode( const char* pName, XmlNodeVector& nodeArr );
	// ̸ Ӽ ̸, Ӽ  ؼ 带 ã´.
	XmlNode*		FindNode( const char* pName, const char* attrName, const char* pAttrValue );

	//  ߰ ۾ ϰ 
	virtual	void	Traverse();

protected:
	virtual	void	OnUpdate();  //Traverse() Ҹ  Լ
	bool			IsExsitAttribute( const char* attrName, const char* pAttrValue );
	void			FindNodeAll( const std::vector<std::string>& tok, int iDepth, XmlNodeVector& nodeArr );

public:
	struct Attribute
	{
		std::string name;
		std::string value;

		Attribute( const char* _name, const char* _value )
		{
			name = _name;
			value = _value;
		}
	};
	typedef std::list <XmlNode*>		ChildList;
	typedef std::vector <Attribute*>	AttributeList;
	AttributeList*	GetAtrributeList()  { return &m_attribute; }
	ChildList*		GetChildList()		{ return &m_child;  }

protected:
	std::string		m_data;
	std::string		m_name;
	XmlNode*		m_pParent;
	ChildList		m_child;  
	AttributeList	m_attribute;
};

void		WriteXml( const char* szName, XmlNode* root );
XmlNode*	ReadXml( const char* szName );
XmlNode*	CreateXmlNode( char* szName );

#include "XmlNode.inl"

#endif